﻿@{
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<style>
    .grey {
        color: black\9;
        background-color: #A9A9A9\9;
    }

    .green {
        color: black\9;
        background-color: #b6ff00\9;
    }

    .yellow {
        color: black\9;
        background-color: yellow\9;
    }

    .red {
        color: black\9;
        background-color: #e83636\9;
    }

    .grey:not(.jqx-grid-cell-hover):not(.jqx-grid-cell-selected), .jqx-widget .green:not(.jqx-grid-cell-hover):not(.jqx-grid-cell-selected) {
        color: black;
        background-color: #A9A9A9;
    }

    .green:not(.jqx-grid-cell-hover):not(.jqx-grid-cell-selected), .jqx-widget .green:not(.jqx-grid-cell-hover):not(.jqx-grid-cell-selected) {
        color: black;
        background-color: #b6ff00;
    }

    .yellow:not(.jqx-grid-cell-hover):not(.jqx-grid-cell-selected), .jqx-widget .yellow:not(.jqx-grid-cell-hover):not(.jqx-grid-cell-selected) {
        color: black;
        background-color: yellow;
    }

    .red:not(.jqx-grid-cell-hover):not(.jqx-grid-cell-selected), .jqx-widget .red:not(.jqx-grid-cell-hover):not(.jqx-grid-cell-selected) {
        color: black;
        background-color: #e83636;
    }
</style>
@section scripts {
    <script>
        $(document).ready(function () {
            var source =
                {
                    datafields:
                    [
                        { name: 'Id', type: 'number' },
                        { name: 'GameId', type: 'string' },
                        { name: 'Game', type: 'string' },
                        { name: 'Warning', type: 'number' },
                        { name: 'Visible', type: 'number' },
                        { name: 'Thumbnail', type: 'string' },
                        { name: 'AddedOn', type: 'date' },
                        { name: 'Company', type: 'string' },
                        { name: 'UserId', type: 'number' },
                        { name: 'TypeName', type: 'string' },
                        { name: 'Api', type: 'number' },
                        { name: 'Deleted', type: 'number' },
                        { name: 'Active', type: 'bool' },
                        { name: 'RequestId', type: 'number' },
                        { name: 'Request', type: 'string' },
                        { name: 'SyncTunnl', type: 'string' }
                    ],
                    enablehover: false,
                    updaterow: function (rowid, rowdata, commit) {
                        // synchronize with the server - send update command
                        var data = "update=true&GameMd5=" + rowdata.GameId + "&Visible=" + rowdata.Visible + "&Approved=" + rowdata.Approved + "&Banner=" + rowdata.Banner;

                        $.ajax({
                            dataType: 'json',
                            url: '/Games/UpdateGamesInline',
                            data: data,
                            success: function (data, status, xhr) {
                                // update command is executed.
                                $("#jqxgrid").jqxGrid('refreshdata');
                                commit(true);
                            },
                            error: function () {
                                // cancel changes.
                                commit(false);
                            }
                        });
                    },
                    datatype: "json",
                    url: "/Games/Get",
                    filter: function () {
                        $("#jqxgrid").jqxGrid('updatebounddata', 'filter');
                    },
                    // update the grid and send a request to the server.
                    sort: function () {
                        $("#jqxgrid").jqxGrid('updatebounddata', 'sort');
                    },
                    root: "Rows",
                    beforeprocessing: function (data) {
                        source.totalrecords = data.TotalRows;
                    }
                };

            var isEditable = function (row) {
                return false;
            }

            var dataAdapter = new $.jqx.dataAdapter(source);

            var columnsrenderer = function (value) {
                return '<div  style="text-align: center; margin-top: 10px;"><b>' + value + '</b></div>';
            }

            var syncRenderer = function (row, columnfield, value, defaulthtml, columnproperties) {
                var color = value == "NOK" ? "red" : "green";
                return '<div style="text-align: center; margin-top:5px;color:' + color + ';">' + value + '</div>';
            }

            var cellsrenderer = function (row, column, value, defaultSettings, columnproperties, rowdata) {
                if (rowdata.Deleted > 0) {
                    return '<div style="margin-top: 5px; margin-left: 15px; font-family: "Roboto", sans-serif !important;">' + value + '</div><div style="margin-left: 15px; font-size:11px; color: red;"> ' + rowdata.GameId + '</div>';
                }
                else {
                    return '<div style="margin-top: 5px; margin-left: 15px; font-family: "Roboto", sans-serif !important;">' + value + '</div><div style="margin-left: 15px; font-size:11px; color: blue;"> ' + rowdata.GameId + '</div>';
                }
            }

            var requestRenderer = function (row, column, value, defaultSettings, columnproperties, rowdata) {
                var id = $("#jqxgrid").jqxGrid('getcellvalue', row, "Id");
                var title = $("#jqxgrid").jqxGrid('getcellvalue', row, "Game").replace(/'/, "");
                var userId = $("#jqxgrid").jqxGrid('getcellvalue', row, "UserId");
                var requestId = $("#jqxgrid").jqxGrid('getcellvalue', row, "RequestId");
                var select = '';

                if (value != '') {

                    if (requestId == 1 || requestId == 3 || requestId == 5) {
                        select = '<select id="selectId' + id + '" onchange="optionRequest(' + "'" + title + "'" + ',' + id + ',this,' + userId + ')"><option selected value="-1">Select</option><option value="2">Active</option><option value="0">Deactive</option></select>';
                    }
                    else if (requestId == 2) {
                        select = '<select id="selectId' + id + '" onchange="optionRequest(' + "'" + title + "'" + ',' + id + ',this,' + userId + ')"><option value="2" selected>Active</option><option value="0">Deactive</option></select>';
                    }
                    else if (requestId == 0 || requestId == 4) {
                        select = '<select id="selectId' + id + '" onchange="optionRequest(' + "'" + title + "'" + ',' + id + ',this,' + userId + ')"><option value="2">Active</option><option selected value="0">Deactive</option></select>';
                    }

                    return '<div  id="cellId' + id + '" data-id="' + requestId + '" style="padding-top: 10px; padding-left: 15px; font-size:12px; width: 100%; height: 100%;font-family: "Roboto", sans-serif !important;float:left;">' + value + '</div><div style="margin-top: -35px;float:Right; margin-right:5px;"> ' + select + '</div>';

                }
            }


            var cellclass = function (row, columnfield, value) {
                var requestId = $("#jqxgrid").jqxGrid('getcellvalue', row, "RequestId");

                if (requestId == 0 || requestId == 4) {
                    return 'red';
                }
                else if (requestId == 3 || requestId == 1 || requestId == 4 || requestId == 5) {
                    return 'yellow';
                }
                else if (requestId == 2) {
                    return 'green';
                }
            }


            $("#jqxgrid").jqxGrid(
                {
                    width: "100%",
                    height: 650,
                    rowsheight: 35,
                    source: dataAdapter,
                    showfilterrow: true,
                    editable: true,
                    filterable: true,
                    pageable: true,
                    sortable: true,
                    pagesize: 20,
                    autoheight: true,
                    selectionmode: 'multiplecellsextended',
                    enablebrowserselection: true,
                    virtualmode: true,
                    rendergridrows: function (obj) {
                        return obj.data;
                    },
                    ready: function () {
                        var filterCells = $("#jqxgrid .jqx-grid-cell-filter-row input");
                        $(filterCells[5]).attr("placeHolder", "Game or GameId");
                    },
                    columns: [
                        { text: 'Id', datafield: 'Id', filtertype: 'textbox', hidden: true },
                        { text: 'Active', datafield: 'Active', filtertype: 'textbox', hidden: true },
                        { text: 'Deleted', datafield: 'Deleted', filtertype: 'textbox', hidden: true },
                        { text: 'Partner', datafield: 'Company', filtertype: 'textbox', width: '12%', renderer: columnsrenderer, sortable: true, cellbeginedit: isEditable },
                        { text: 'UserId', datafield: 'UserId', filtertype: 'textbox', width: '5%', renderer: columnsrenderer, sortable: true, cellbeginedit: isEditable },
                        { text: 'Game', datafield: 'Game', filtertype: 'textbox', width: '17%', renderer: columnsrenderer, cellsrenderer: cellsrenderer, sortable: true, cellbeginedit: isEditable },
                        { text: 'Type', datafield: 'TypeName', filtertype: 'textbox', width: '5%', renderer: columnsrenderer, sortable: true, cellbeginedit: isEditable },
                        {
                            text: 'Active', datafield: 'Visible', filtertype: 'textbox', renderer: columnsrenderer, cellsalign: 'center', width: '5%', sortable: true,
                            validation: function (cell, value) {
                                if (value > 1 || value < 0) {
                                    return { result: false, message: "Must either be 0 or 1!" };
                                }
                                return true;
                            }
                        },
                        { text: 'Analytics', datafield: 'Api', filtertype: 'textbox', renderer: columnsrenderer, cellsalign: 'center', width: '7%', sortable: true, cellbeginedit: isEditable },
                        { text: 'Sync Tunnl', datafield: 'SyncTunnl', filtertype: 'textbox', cellsrenderer: syncRenderer, renderer: columnsrenderer, width: '8%', sortable: true },
                        { text: 'Added On', datafield: 'AddedOn', filtertype: 'date', width: '7%', cellsalign: 'center', renderer: columnsrenderer, sortable: true, cellbeginedit: isEditable, cellsformat: 'dd/MM/yyyy', editable: false },
                        {
                            text: 'Request', datafield: 'Request', filtertype: 'textbox', renderer: columnsrenderer, width: '15%', sortable: true, editable: false, cellclassname: cellclass, cellsrenderer: requestRenderer
                        },
                        {
                            text: 'Edit', datafield: 'Edit', columntype: 'button', width: '6%', filterable: false, renderer: columnsrenderer, cellsrenderer: function (row, rowdata) {
                                if ($("#jqxgrid").jqxGrid('getcellvalue', row, "Deleted") == 2) {
                                    return "Deleted";
                                }
                                else {
                                    return "Edit";
                                }
                            }, buttonclick: function (row, rowdata) {
                                if ($("#jqxgrid").jqxGrid('getcellvalue', row, "Deleted") != 2) {
                                    editrowindex = row;
                                    var id = $("#jqxgrid").jqxGrid('getcellvalue', row, "Id");
                                    window.location = '/Games/Edit/' + id;
                                }
                            }
                        },
                        {
                            text: 'Feature', columntype: 'button', width: '7%', id: "FeaturedButton", filterable: false, renderer: columnsrenderer, cellsrenderer: function (row, rowdata) {
                                if ($("#jqxgrid").jqxGrid('getcellvalue', row, "Deleted") == 2) {
                                    return "Deleted";
                                }
                                else {
                                    return "Feature";
                                }
                            }, buttonclick: function (row) {
                                if ($("#jqxgrid").jqxGrid('getcellvalue', row, "Deleted") != 2) {
                                    editrowindex = row;
                                    var id = $("#jqxgrid").jqxGrid('getcellvalue', row, "Id");
                                    window.location = '/Games/Feature/' + id;
                                }
                            }
                        },
                        {
                            text: 'Best', columntype: 'button', width: '7%', id: "BestButton", filterable: false, renderer: columnsrenderer, cellsrenderer: function (row, rowdata) {
                                if ($("#jqxgrid").jqxGrid('getcellvalue', row, "Deleted") == 2) {
                                    return "Deleted";
                                }
                                else {
                                    return "Best";
                                }
                            }, buttonclick: function (row) {
                                if ($("#jqxgrid").jqxGrid('getcellvalue', row, "Deleted") != 2) {
                                    editrowindex = row;
                                    var id = $("#jqxgrid").jqxGrid('getcellvalue', row, "Id");
                                    window.location = '/Games/Best/' + id;
                                }
                            }
                        },
                        {
                            text: 'Domain', columntype: 'button', width: '7%', id: "DomainButton", filterable: false, renderer: columnsrenderer, cellsrenderer: function (row, rowdata) {
                                if ($("#jqxgrid").jqxGrid('getcellvalue', row, "Deleted") == 2) {
                                    return "Deleted";
                                }
                                else {
                                    var requestId = $("#jqxgrid").jqxGrid('getcellvalue', row, "RequestId");
                                    if (requestId == 2) {
                                        return "Domain";
                                    }
                                    else {
                                        return '<input disabled="false" type="button" style="color:red;opacity: 0.99; position: absolute; top: 0%; left: 0%; padding: 0px; margin-top: -15px; margin-left: -52px; height: 31px; width: 103.24px;" value="Domain" hidefocus="true" role="button" class="jqx-rc-all jqx-button jqx-widget jqx-fill-state-normal" aria-disabled="false">';
                                    }
                                }
                            }, buttonclick: function (row) {
                                if ($("#jqxgrid").jqxGrid('getcellvalue', row, "Deleted") != 2) {
                                    var requestId = $("#jqxgrid").jqxGrid('getcellvalue', row, "RequestId");
                                    if (requestId == 2) {
                                        editrowindex = row;
                                        var gameMD5 = $("#jqxgrid").jqxGrid('getcellvalue', row, "GameId");
                                        window.location = '/Games/UnPublishedDomains/' + gameMD5;
                                    }
                                }
                            }
                        }

                    ]
                })
        });
        function ChangeColor(id) {

            $('#' + id).css("color", "red");

        }
    </script>
}
<div class="column">
    <div class="menu" style="text-align:left; color:black">
        <h2 style="width:100%; margin-left: 0 auto; margin-right:0 auto;"> Games</h2>
        <div id="jqxgrid" style="width: 100% !important; margin-top:-20px;">
            <script type="text/javascript">

                var optionRequest = function (title, id, select, userId) {

                    var message = "";
                    var condition = "";
                    var userRequestId = $('#cellId' + id).data('id');
                    var adminRequestId = select.value;


                    if (userRequestId == 1 && adminRequestId == 2) {
                        condition = "publish-approved";
                    }
                    else if (userRequestId == 5 && adminRequestId == 2) {
                        condition = "deactivate-declined";
                    }
                    else if (userRequestId == 5 && adminRequestId == 0) {
                        condition = "deactivate-approved";
                    }
                    else if (userRequestId == 1 && adminRequestId == 0) {
                        condition = "publish-declined";
                    }


                    if (select.value != -1) {
                        if (select.value == 2) {
                            message = "Are you sure that you want to ACTIVATE " + title + " right now?";
                        }
                        else if (select.value == 0) {
                            message = "Are you sure that you want to DEACTIVATE " + title + " right now?";
                        }

                        if (confirm(message)) {

                            var data = "id=" + id + "&requestId=" + adminRequestId + "&userId=" + userId + "&title=" + title + "&condition=" + condition;

                            $('#cellId' + id).css('background-color', 'grey').text('Waiting...');
                            $('#selectId' + id).css('background-color', 'grey').prop("disabled", true);

                            $.ajax({
                                dataType: 'json',
                                url: '/Games/UpdateRequest/',
                                data: data,
                                success: function (result) {

                                    $('#selectId' + id).css('background-color', '').prop("disabled", false);

                                    if (select.value == '2') {
                                        $('#cellId' + id).css('background-color', '#b6ff00').text('Active').data('id', '2');
                                    }
                                    else if (select.value == '0') {
                                        $('#cellId' + id).css('background-color', '#e83636').text('Deactive').data('id', '0');
                                    }
                                },
                                error: function () {

                                }

                            });
                        }
                        else {

                            var value = -1;
                            if (select.value == 2) { value = -1; }
                            else if (select.value == -1) { value = 2; }

                            $('#selectId' + id).val(value);
                            return false;
                        }
                    }
                };

            </script>
        </div>
    </div>
</div>
